//-----------------------------------------------------------------------------
// Copyright (c) 2012 GarageGames, LLC
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
// IN THE SOFTWARE.
//-----------------------------------------------------------------------------

// This is the default save location for any TSForestItemData(s) created in the
// Forest Editor Editor (this script is executed from onServerCreated())

datablock TSForestItemData(fir_01_15m_a)
{
   internalName = "fir_01_15m_a";
   shapeFile = "art/shapes/trees/fir/fir_01/fir_01_15m_a.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(fir_01_15m_b)
{
   internalName = "fir_01_15m_b";
   shapeFile = "art/shapes/trees/fir/fir_01/fir_01_15m_b.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(fir_01_15m_c)
{
   internalName = "fir_01_15m_c";
   shapeFile = "art/shapes/trees/fir/fir_01/fir_01_15m_c.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(fir_01_10m_b)
{
   internalName = "fir_01_10m_b";
   shapeFile = "art/shapes/trees/fir/fir_01/fir_01_10m_b.dts";
   windScale = "0.75";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
   radius = "0.8";
};

datablock TSForestItemData(fir_01_10m_a)
{
   internalName = "fir_01_10m_a";
   shapeFile = "art/shapes/trees/fir/fir_01/fir_01_10m_a.dts";
   windScale = "0.75";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
   radius = "0.8";
};

datablock TSForestItemData(fir_01_5m_b)
{
   internalName = "fir_01_5m_b";
   shapeFile = "art/shapes/trees/fir/fir_01/fir_01_5m_b.dts";
   windScale = "0.5";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(fir_01_5m_a)
{
   internalName = "fir_01_5m_a";
   shapeFile = "art/shapes/trees/fir/fir_01/fir_01_5m_a.dts";
   windScale = "0.5";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(fern_01_a)
{
   internalName = "fern_01_a";
   shapeFile = "art/shapes/plants/ferns/fern_01/fern_01_a.dts";
   radius = "0.2";
   windScale = "1";
   trunkBendScale = "0.05";
   branchAmp = "0.02";
   detailAmp = "0.05";
   detailFreq = "0.02";
};

datablock TSForestItemData(fern_01_c)
{
   internalName = "fern_01_c";
   shapeFile = "art/shapes/plants/ferns/fern_01/fern_01_c.dts";
   radius = "0.2";
   windScale = "1";
   trunkBendScale = "0.05";
   branchAmp = "0.02";
   detailAmp = "0.05";
   detailFreq = "0.02";
};

datablock TSForestItemData(fern_01_b)
{
   internalName = "fern_01_b";
   shapeFile = "art/shapes/plants/ferns/fern_01/fern_01_b.dts";
   radius = "0.2";
   windScale = "1";
   trunkBendScale = "0.05";
   branchAmp = "0.02";
   detailAmp = "0.05";
   detailFreq = "0.02";
};

datablock TSForestItemData(palm_01_bush)
{
   internalName = "palm_01_bush";
   shapeFile = "art/shapes/trees/palm/palm_01/palm_01_bush.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(palm_01_short)
{
   internalName = "palm_01_short";
   shapeFile = "art/shapes/trees/palm/palm_01/palm_01_short.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(palm_01_tall)
{
   internalName = "palm_01_tall";
   shapeFile = "art/shapes/trees/palm/palm_01/palm_01_tall.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(palm_01_tall_leaning)
{
   internalName = "palm_01_tall_leaning";
   shapeFile = "art/shapes/trees/palm/palm_01/palm_01_tall_leaning.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(canopy_01_shrub)
{
   internalName = "canopy_01_shrub";
   shapeFile = "art/shapes/trees/canopy/canopy_01/canopy_01_shrub.dts";
   windScale = "0.7";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(canopy_01_a)
{
   internalName = "canopy_01_a";
   shapeFile = "art/shapes/trees/canopy/canopy_01/canopy_01_a.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(canopy_01_a_vines)
{
   internalName = "canopy_01_a_vines";
   shapeFile = "art/shapes/trees/canopy/canopy_01/canopy_01_a_vines.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(canopy_01_b)
{
   internalName = "canopy_01_b";
   shapeFile = "art/shapes/trees/canopy/canopy_01/canopy_01_b.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(canopy_01_c)
{
   internalName = "canopy_01_c";
   shapeFile = "art/shapes/trees/canopy/canopy_01/canopy_01_c.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
};


datablock TSForestItemData(banana_01_a)
{
   internalName = "banana_01_a";
   shapeFile = "art/shapes/trees/palm/banana_01/banana_01_a.dts";
   windScale = "1";
   trunkBendScale = "0.01";
   branchAmp = "0.03";
   detailAmp = "0.1";
   detailFreq = "0.05";
};

datablock TSForestItemData(fern_tropical_01_a)
{
   internalName = "fern_tropical_01_a";
   shapeFile = "art/shapes/plants/ferns/fern_tropical_01/fern_tropical_01_a.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.07";
   radius = "0.5";
};

datablock TSForestItemData(thintree_01_b)
{
   internalName = "thintree_01_b";
   shapeFile = "art/shapes/trees/generic/thintree_01/thintree_01_b.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
   radius = "0.5";
};

datablock TSForestItemData(thintree_01_c)
{
   internalName = "thintree_01_c";
   shapeFile = "art/shapes/trees/generic/thintree_01/thintree_01_c.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
   radius = "0.5";
};

datablock TSForestItemData(thintree_01_a)
{
   internalName = "thintree_01_a";
   shapeFile = "art/shapes/trees/generic/thintree_01/thintree_01_a.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.1";
   detailAmp = "0.1";
   detailFreq = "0.1";
   radius = "0.5";
};

datablock TSForestItemData(deadbush_01_a)
{
   internalName = "deadbush_01_a";
   shapeFile = "art/shapes/bushes/dead/deadbush_01/deadbush_01_a.dts";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.05";
   detailAmp = "0.05";
   detailFreq = "0.03";
   radius = "0.3";
};

datablock TSForestItemData(deadbush_01_c)
{
   internalName = "deadbush_01_c";
   shapeFile = "art/shapes/bushes/dead/deadbush_01/deadbush_01_c.dts";
   radius = "0.5";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.05";
   detailAmp = "0.05";
   detailFreq = "0.03";
};

datablock TSForestItemData(deadbush_01_b)
{
   internalName = "deadbush_01_b";
   shapeFile = "art/shapes/bushes/dead/deadbush_01/deadbush_01_b.dts";
   radius = "0.3";
   windScale = "1";
   trunkBendScale = "0.02";
   branchAmp = "0.05";
   detailAmp = "0.05";
   detailFreq = "0.03";
};

datablock TSForestItemData(birch_01_b)
{
   internalName = "birch_01_b";
   shapeFile = "art/shapes/trees/birch/birch_01/birch_01_b.dts";
   windScale = "1";
   trunkBendScale = "0.015";
   branchAmp = "0.05";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(birch_01_c)
{
   internalName = "birch_01_c";
   shapeFile = "art/shapes/trees/birch/birch_01/birch_01_c.dts";
   windScale = "1";
   trunkBendScale = "0.015";
   branchAmp = "0.05";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(birch_01_d)
{
   internalName = "birch_01_d";
   shapeFile = "art/shapes/trees/birch/birch_01/birch_01_d.dts";
   windScale = "1";
   trunkBendScale = "0.015";
   branchAmp = "0.05";
   detailAmp = "0.1";
   detailFreq = "0.1";
};

datablock TSForestItemData(birch_01_a)
{
   internalName = "birch_01_a";
   shapeFile = "art/shapes/trees/birch/birch_01/birch_01_a.dts";
   windScale = "1";
   trunkBendScale = "0.015";
   branchAmp = "0.05";
   detailAmp = "0.1";
   detailFreq = "0.1";
};
